; NEO SNES Myth macros

 .MACRO MOV_BOOT_TO_SRAM
        LDX     #$0000
        LDA     #$0000+\1      ; READ GBA CARD
	-:
        STA.L   \1*$10000+$500000,X  ; WRITE PSRAM
        INC     A
        INX
        INX
        BNE     -

                      
        LDX     #$0000      ;  MOVE BOOT CODE TO SRAM
        LDA     #$0000+\1
	MOV_BOOT_TO_SRAM\1:
        CMP.L   \1*$10000+$500000,X
        BNE     MOV_BOOT_TO_SRAM\1_BREAK
        INC     A
        INX                 ;0
        INX
        BNE     MOV_BOOT_TO_SRAM\1          ;0
        JMP     +
	MOV_BOOT_TO_SRAM\1_BREAK:
	JMP    MOV_BOOT_TO_SRAM_BREAK_LAST
	+:
 .ENDM


 .MACRO MOV_PSRAM_SETUP 
        LDA    RZX
        CMP    #\1
        BNE    +
        LDA    #\2  
        STA    RSZ
          
        LDA    #<\3     
        STA    AP0
        LDA    #>\3     
        STA    AP1
         
        LDA    #\4     
        STA    WAZ0
         
        LDA    #\5     
        STA    WAZ1
        JMP    MOV_PSRAM
	+:
 .ENDM


 .MACRO VERIFY_PSRAM 
        LDA     #(\1 + 20)
        JSR     PRINT
        LDA     #\1       ;PSRAM   BANK
        STA     MYTH_PRAM_BIO
        JSR     TEST_PARMA0
        LDA     TERR
        CMP     #$00
        BEQ	+
        JMP	TS_ERR
        +:
 .ENDM


 .MACRO MAP_SRAM_CHECK
 	 CMP     #\1
         BNE     +
         STA     MYTH_SRAM_TYPE  ; SET SRAM SAVE TYPE
         LDA     #\2
         STA     MYTH_SRAM_MAP   ; SET $206000
         JMP     MAP_SRAM_DONE
	 +:
 .ENDM
 